#define Version	"Spin Version 2.7.5 -- 7 October 1995"
#define Source	"leader"

#define uchar	unsigned char
#define DELTA	500
#if !defined(NFAIR)
#define NFAIR	2	/* must be >= 2 */
#endif
#define INLINE	1
#define endclaim	endstate-1

short nstates1=12;	/* :init: */
#define endstate1	11
short src_ln1 [] = {
	  0,  51,  53,  54,  55,  56,  56,  52, 
	 58,  52,  50,  59,   0, };
uchar reached1 [] = {
	  0,   1,   1,   0,   0,   1,   1,   0, 
	  1,   1,   0,   0,   0, };

short nstates0=35;	/* node */
#define endstate0	34
short src_ln0 [] = {
	  0,  16,  17,  18,  20,  22,  24,  24, 
	 25,  26,  27,  23,  29,  29,  29,  21, 
	 31,  31,  33,  35,  36,  37,  38,  39, 
	 40,  34,  42,  42,  43,  32,  45,  19, 
	 46,  19,  46,   0, };
uchar reached0 [] = {
	  0,   0,   0,   0,   1,   1,   1,   0, 
	  0,   1,   0,   0,   1,   1,   0,   0, 
	  1,   1,   1,   1,   0,   0,   1,   0, 
	  0,   0,   1,   1,   0,   0,   1,   0, 
	  1,   1,   0,   0, };
#define SYNC	0
#define ASYNC	1

typedef struct P1 { /* :init: */
	unsigned _pid : 8;  /* 0..255 */
	unsigned _t   : 2; /* proctype */
	unsigned _p   : 7; /* state    */
	uchar proc;
} P1;
#define Air1	(sizeof(P1) - Offsetof(P1, proc) - 1*sizeof(uchar))
typedef struct P0 { /* node */
	unsigned _pid : 8;  /* 0..255 */
	unsigned _t   : 2; /* proctype */
	unsigned _p   : 7; /* state    */
	unsigned Active : 1;
	uchar id;
	uchar nr;
	uchar maxi;
	uchar n_r;
	uchar in;
	uchar out;
} P0;
#define Air0	(sizeof(P0) - Offsetof(P0, out) - 1*sizeof(uchar))
#ifdef VERI
#define BASE	1
#else
#define BASE	0
#endif
#ifdef VERBOSE
#define CHECK
#define DEBUG
#endif
#ifndef REDUCE
#define XUSAFE
#endif
#ifdef REDUCE
#define PARTIAL
#ifdef BITSTATE
#define CNTRSTACK
#else
#define FULLSTACK
#endif
#endif
#ifdef BITSTATE
#define NOCOMP
#endif
#ifndef MEMCNT
#define MEMCNT	30
#endif
#ifdef COLLAPSE2
#define COLLAPSE
#endif
#ifdef COLLAPSE3
#define COLLAPSE2
#define COLLAPSE
#endif
#ifdef COLLAPSE4
#define COLLAPSE3
#define COLLAPSE2
#define COLLAPSE
#endif
#define qptr(x)	(((uchar *)&now)+q_offset[x])
#define pptr(x)	(((uchar *)&now)+proc_offset[x])
#define Pptr(x)	((proc_offset[x])?pptr(x):noptr)
#define q_sz(x)	(((Q0 *)qptr(x))->Qlen)

#define MAXQ   	255
#define MAXPROC	255
#define WS		sizeof(long)   /* word size in bytes */
#ifndef VECTORSZ
#define VECTORSZ	1024           /* sv   size in bytes */
#endif

typedef struct Stack  {	 /* for queues and processes */
#if VECTORSZ>32000
	int o_delta;
	int o_offset;
	int o_skip;
	int o_delqs;
#else
	short o_delta;
	short o_offset;
	short o_skip;
	short o_delqs;
#endif
#ifndef XUSAFE
	char *o_name;
#endif
	char *body;
	struct Stack *nxt;
	struct Stack *lst;
} Stack;

typedef struct Svtack { /* for complete state vector */
#if VECTORSZ>32000
	int o_delta;
	int m_delta;
#else
	short o_delta;	 /* current size of frame */
	short m_delta;	 /* maximum size of frame */
#endif
#if SYNC
	short o_boq;
#endif
	char *body;
	struct Svtack *nxt;
	struct Svtack *lst;
} Svtack;

typedef struct Trans {
	short atom;	/* if &2 = atomic trans; if &8 local */
	short st;	/* the nextstate */
#ifdef HAS_UNLESS
	short escp[HAS_UNLESS];	/* lists the escape states */
	short e_trans;	/* if set, this is an escp-trans */
#endif
	short tpe[2];	/* class of operation (for reduction) */
	uchar qu[6];	/* for conditional selections: qid's  */
	uchar ty[6];	/* for conditional selections: type's */
#ifdef NIBIS
	short om;	/* completion status of preselects */
#endif
	char *tp;	/* src txt of statement */
	int t_id;	/* transition id, unique within proc */
	int forw;	/* index for forward transition */
	int back;	/* index for return  transition */
	struct Trans *nxt;
} Trans;

Trans ***trans;	/* 1 ptr per state per proctype */

#if defined(FULLSTACK)
struct H_el *Lstate;
#endif
int depthfound = -1;	/* loop detection */
int proc_offset[MAXPROC], proc_skip[MAXPROC];
int q_offset[MAXQ], q_skip[MAXQ];
int vsize;		/* vector size in bytes */
short boq = -1;	/* blocked_on_queue status */
typedef struct State {
	uchar _nr_pr;
	uchar _nr_qs;
	uchar   _a_t;	/* cycle detection */
#ifndef NOFAIR
	uchar   _cnt[NFAIR];	/* counters, weak fairness */
#endif
#ifdef HAS_LAST
	uchar  _last; /* pid executed in last timestep */
#endif
	uchar q[5];
	uchar sv[VECTORSZ];
} State;

#define start1	10
#define start0	1
#define ACCEPT_LAB	0 /* accept labels */
#define PROG_LAB	0 /* progress labels */
uchar *accpstate[3];
uchar *progstate[3];
uchar *reached[3];
uchar *stopstate[3];
short q_flds[6];
typedef struct Q5 {
	uchar Qlen;	/* q_size */
	uchar _t;	/* q_type */
	struct {
		uchar fld0;
		uchar fld1;
	} contents[20];
} Q5;
typedef struct Q4 {
	uchar Qlen;	/* q_size */
	uchar _t;	/* q_type */
	struct {
		uchar fld0;
		uchar fld1;
	} contents[20];
} Q4;
typedef struct Q3 {
	uchar Qlen;	/* q_size */
	uchar _t;	/* q_type */
	struct {
		uchar fld0;
		uchar fld1;
	} contents[20];
} Q3;
typedef struct Q2 {
	uchar Qlen;	/* q_size */
	uchar _t;	/* q_type */
	struct {
		uchar fld0;
		uchar fld1;
	} contents[20];
} Q2;
typedef struct Q1 {
	uchar Qlen;	/* q_size */
	uchar _t;	/* q_type */
	struct {
		uchar fld0;
		uchar fld1;
	} contents[20];
} Q1;
typedef struct Q0 {	/* generic q */
	uchar Qlen, _t;
} Q0;

/** function prototypes **/
char *emalloc(unsigned);
char *malloc(unsigned);
int Boundcheck(int, int, int, int, Trans *);
int abort(void);

int addqueue(int, int);
int atoi(char *);
int close(int);
int creat(char *, unsigned short);
int delproc(int, int);
int endstate(void);
int hstore(char *, int, short);
int q_cond(Trans *);
int q_full(int);
int q_len(int);
int q_zero(int);
int qrecv(int, int, int, int);
int unsend(int);
int write(int, void *, unsigned);
void *sbrk(int);
void Uerror(char *);
void assert(int, char *, int, int, Trans *);
void checkcycles(void);
void crack(int, int, Trans *, short *);
void d_hash(uchar *, int);
void delq(int);
void do_reach(void);
void exit(int);
void hinit(void);
void imed(Trans *, int, int);
#ifndef RUNTIME
void new_state(void);
#endif
#ifdef RUNTIME
void rt_wrapup(int);
#endif
void p_restor(int);
void putpeg(int, int);
void putrail(void);
void q_restor(void);
void retrans(int, int, int, short *, uchar *);
void settable(void);
void setq_claim(int, int, char *, int, char *);
void sv_restor(int);
void sv_save(char *);
void tagtable(int, int, int, short *, uchar *);
void uerror(char *);
void unrecv(int, int, int, int, int);
void usage(FILE *);
void wrap_stats(void);
void xrefsrc(int, int, int);
#if defined(FULLSTACK) && defined(BITSTATE)
int  onstack_now(void);
void onstack_init(void);
void onstack_put(void);
void onstack_zap(void);
#endif
#ifndef XUSAFE
int q_S_check(int, int);
int q_R_check(int, int);
uchar q_claim[MAXQ+1];
char *q_name[MAXQ+1];
char *p_name[MAXPROC+1];
#endif
void qsend(int, int, int, int);
#define Addproc(x)	addproc(x, 0, 0, 0)
#define LOCAL	1
#define Q_FULL_F	2
#define Q_EMPT_F	3
#define Q_EMPT_T	4
#define Q_FULL_T	5
#define TIMEOUT_F	6
#define GLOBAL	7
#define BAD	8
#define NTRANS	39
#ifdef PEG
	long peg[NTRANS];
#endif
