static char *code_com[] = {
	"/* $Id: com.c,v 1.3 1995/11/22 17:00:21 loeffler Exp loeffler $ */",
	"",
	"/* Runtime -*- C -*-    */",
	"/* S. Loeffler 11/95    */",
	"",
	"#define RUNTIME          /* Disables Parts of the Analyzer-Code */",
	"",
	"#include \"comstmng.c\"    /* Procedures from the Analyzer-Code */",
	"",
	"/* ------------------------------------------------------------------ */",
	"",
	"",
	"void",
	"runtime(void)",
	"{ ",
	"  register Trans *t;",
	"  char ot,m;",
	"  short flag_atom;",
	"  short tt;",
	"  short II;",
	"  short From, To;    /* Range of (active) Proctypes being searched */",
	"  ",
	"  stack	 = (Stack *) emalloc(sizeof(Stack));",
	"  ",
	"  /* a place to point for Pptr of non-running procs: */",
	"  noptr	= (uchar *) emalloc(Maxbody * sizeof(char));",
	"",
	"",
	"",
	"  run();                          /* Initializations of some Arrays etc. */",
	"                                  /* This is just the HEAD of the */",
	"                                  /* Analyzers run() Procedure! */",
	"",
	"  hinit();                                /* Initialize the State Vector */",
	"                                          /* (allocate Memory) */",
	"",
	"  active_procs();                         /* calls addproc(0) to add the */",
	"                                          /* init proctype */",
	"",
	"MainLoop:  ",
	"  From = now._nr_pr-1; ",
	"  To = 0;               ",
	"",
	"  for (II=From; II>=To; II-=1)          /* For all active Proctypes... */",
	"                                      ",
	"  {",
	"    this = pptr(II);",
	"    ot = (uchar) ((P0 *)this)->_t;  /* Current Proctype */",
	"",
	"lbl_atom: /* if atomic move, dont leave this proctype */",
	"    tt = (short) ((P0 *)this)->_p;  /* Current State */",
	"   ",
	"    /* Now that we have selected a Proctype */",
	"    /* search it for executable transitions */",
	"#ifdef DEBUG",
	"    printf(\"Current: Proctype %d/[%d..%d] (ID %d) State %d \\n\",II,From,To,ot,tt);",
	"#endif   ",
	"",
	"    /* choose one... */",
	"    for (t = trans[ot][tt]; t; t = t->nxt) /* Loop over Transitions for this */",
	"                                           /* Proctype / State */",
	"      {",
	"	if (t->nxt) /* Just a bit of random for now... */",
	"	  { ",
	"	    if (rand(0)%2==0){ t=t->nxt; } /* skip... */",
	"	  }",
	"",
	"#ifdef DEBUG	",
	"	printf(\"Select Transition [id %d] tr %d \\\"%s\\\" (to go to State %d).\\n\",",
	"	       t->t_id,t->forw,t->tp,t->st);",
	"#endif",
	"	",
	"	if (t->atom&2) ",
	"	  {",
	"#ifdef DEBUG",
	"	    printf(\"atom(%x) Atomic Bit is set, so we wont allow to change the proctype.\\n\",t->atom);",
	"#endif",
	"	    flag_atom = 1;",
	"	  }",
	"	else",
	"	  {",
	"	    flag_atom = 0;  ",
	"	  }",
	"",
	"	/* Try to execute the Transition */",
	"#include \"com.m\"",
	"	/* if it is not executable, it does a continue; */",
	"	/* otherwise it jumps to P999 (see below) */ ",
	"",
	"#ifdef DEBUG	",
	"	printf(\"It failed.\\n\");",
	"#endif",
	"",
	"      }  ",
	"    /* no t->nxt... */",
	"#ifdef DEBUG",
	"    printf(\"There is no possible move for this state.\\n\");",
	"    printf(\"Maybe its possible to continue with another proctype?\\n\");",
	"#endif",
	"    goto lbl_nxt;  /* really should check for atomic here! */",
	"",
	"  /* com.m jumps here if the move is successful... */",
	"P999:",
	"  ",
	"  if (t->st >0)",
	"    {",
	"      ((P0 *)this)->_p = t->st;          /* Set \"this\"_p to the new State */",
	"    }",
	"  else",
	"    {",
	"#ifdef DEBUG",
	"      printf(\"End.\\n\");",
	"#endif",
	"      exit(0);",
	"    }",
	"",
	"lbl_cont:",
	"  /* ... continue with the next proctype ... */",
	"  if (flag_atom==1)",
	"    {",
	"#ifdef DEBUG",
	"      printf(\"ATOMIC MOVE\\n\");",
	"#endif",
	"      goto lbl_atom;",
	"    }",
	"lbl_nxt: ",
	"  } /* next */",
	"  goto MainLoop;",
	"",
	"}",
	"",
	"",
	"/* For the Runtime System, we have our own wrapup() Function */",
	"",
	"void",
	"rt_wrapup(int arg)",
	"{",
	"  signal(SIGINT, SIG_DFL); /* Reset SIGINT to the Default Action */",
	"  printf(\"\\n\\nInterrupt.\\nExecutable produced by %s stopped.\\n\",Version);",
	"  exit(arg);",
	"}",
	"",
	"",
	"main(int argc, char *argv[])",
	"{",
	"  FILE *fd_e = stderr;",
	"  signal(SIGINT, rt_wrapup);",
	"  runtime();",
	"  exit(0);",
	"}",
	"",
	"",
	"",
	"",
	"",
	"",
	0,
};

